﻿@page "/shop"
@using RPG.Hero;
@using RPG.Hero.Weapons;

@inject NavigationManager NavigationManager

<h3>Shop</h3>

<div class="content">
    <div class="goods-container">
        @foreach(var item in Weapons)
        {
            <div class="good">
                <img src="@item.ImageRoute" alt="@item.GetType()">
                @if (Singleton.GetInstance().Weapon.GetType() != item.GetType())
                {
                    <button class="btn btn-success" @onclick="() => BuyWeapon(item)">Buy</button>
                }
                else
                {
                    <button class="btn btn-danger">Sell</button>
                }
            </div>
        }
    </div>
</div>


@if (isModalVisible)
{
    <div class="modal fade show" style="display: block;">
        <div class="modal-dialog">
            <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title">Buy warning</h5>
                    <button type="button" class="close" data-dismiss="modal" aria-label="Close" @onclick="HideModal">
                        <span aria-hidden="true">&times;</span>
                    </button>
                </div>
                <div class="modal-body">
                    You have not enough money to buy this weapon
                </div>
                <div class="modal-footer">
                    <button type="button" class="btn btn-warning" data-dismiss="modal" @onclick="HideModal">Close</button>
                </div>
            </div>
        </div>
    </div>
}


@code {
    List<IWeapon> Weapons = new();

    private bool isModalVisible = false;

    private void ShowModal()
    {
        isModalVisible = true;
    }

    private void HideModal()
    {
        isModalVisible = false;
    }

    protected override void OnInitialized()
    {
        var magicFactory = new MagicWeaponFactory();
        var physicalFactory = new PhysicalWeaponFactory();

        Weapons.Add(magicFactory.CreateSword());
        Weapons.Add(physicalFactory.CreateSword());

        base.OnInitialized();
    }

    public void BuyWeapon(IWeapon weapon)
    {
        if(Singleton.GetInstance().Money < weapon.Price)
        {
            ShowModal();
            return;
        }

        Singleton.GetInstance().Weapon = weapon;
        Singleton.GetInstance().Money -= weapon.Price;

        RefreshPage();
    }

    private void RefreshPage()
    {
        NavigationManager.NavigateTo(NavigationManager.Uri, true);
    }

}
